%add a vertex to a polyhedron
function [Inequalities, Polyhedron, memory] = addvertex(vertex, Inequalities, Polyhedron)

%inicialization
Polyhedron(end+1).c=vertex;
Polyhedron(end).ineq=[];
queue=[];
stupid=[];
horizont=[];
dim = length(vertex);
memory = 0;

%cycle finds the first visible facet
for j=1:length(Polyhedron)
	for k=1:length(Polyhedron(end-j+1).ineq)
		actual=Polyhedron(end-j+1).ineq(end-k+1);
		vis=isvisible(actual,vertex);
		if vis
			queue=actual;
			if vis==2
			%vertex lies in the facet
			%the facet i saved for future use
				stupid=actual;
      end %if;
			break;
    end %if;
	end %for
	if ~queueisempty(queue)
	%break outer cycle
		break;
    end %if;
end %for  
time = toc;
disp(time);
%searching for all visible facets and creating horizont  
sawfacets = [];
while ~queueisempty(queue) 
	[actual,queue]=queuepop(queue,1);
	[Inequalities, Polyhedron]=deleteineqocc(actual,Polyhedron, Inequalities);
	verticeshorizont=actual.vert;
	ridges=gencombel(dim-1,verticeshorizont);
	%test facets around for visibility, using ridges to find them 
	for l=1:rows(ridges)
		commfacet=commonfacet(Polyhedron(ridges(l,1)).ineq,ridges(l,:));
		if (length(commfacet) >0)
			vis=isvisible(commfacet,vertex);
			if vis==1
				%visible facet
        if ~containrow(sawfacets, commfacet.inequal)
          %is added to queue and to trie
				  queue=queuepush(queue,commfacet);
          sawfacets(end+1,:) = commfacet.inequal;
        end %if
			elseif vis==0
				%obscure facet, there is part of horizont here
        %test if actual is not stupid (diff behavior)
				if length(stupid)==0
					horizont(end+1,:)=ridges(l,:);
				elseif ~same(actual.inequal,stupid.inequal)
					horizont(end+1,:)=ridges(l,:);
        end %if
			else
				%vertex lies in this facet
        %add to the facet, not horizont
        if ~containrow(sawfacets,commfacet.inequal)
          commfacet.vert(end+1)=length(Polyhedron);
          for m=1:length(commfacet.vert)-1
					  Polyhedron(commfacet.vert(m))=updateineq(Polyhedron(commfacet.vert(m)),commfacet);
				  end %for
				  Polyhedron(end).ineq(end+1).inequal=commfacet.inequal;
				  Polyhedron(end).ineq(end).vert=commfacet.vert;
				  Polyhedron(end).ineq(end).res=commfacet.res;
          sawfacets(end+1,:) = commfacet.inequal;
        end %if
      end %if
    end %if;	
	end %for
  
  %memory measurement
  if memory < actmemory(whos)
    memory = actmemory(whos);
  end %if   
time = toc;
disp(time);
  
end %while
%creation of new facets
if length(stupid) >0
%add stupid again (was deleted)
	stupid.vert(end+1)=length(Polyhedron);
	for m=1:length(stupid.vert)
    Polyhedron(stupid.vert(m)).ineq(end+1).inequal=stupid.inequal;
		Polyhedron(stupid.vert(m)).ineq(end).vert=stupid.vert;
		Polyhedron(stupid.vert(m)).ineq(end).res=stupid.res;
        
	end %for
	Inequalities(stupid.res(1),:) = stupid.inequal;
end %if
%horizont ridges and the vertex define new facets
newfacets(1).inequal = [];
newfacets(1).vert = [];
newfacets(1).res = [];
for n=1:rows(horizont)
  add = 1;
  for r=2:length(newfacets)
    diff = difference(horizont(n,:), newfacets(r).vert(1:end-1));
    if length(diff) == 1 && vertexliesinhyp(Polyhedron(diff).c,newfacets(r).inequal)
      newfacets(r).vert(end) = diff;
      newfacets(r).vert(end+1) = length(Polyhedron);
      Polyhedron(diff).ineq(end+1) = newfacets(r);
      for m=1:length(newfacets(r).vert)
			  Polyhedron(newfacets(r).vert(m))=updateineq(Polyhedron(newfacets(r).vert(m)),newfacets(r));
			end %for
      add = 0;
    elseif length(diff) == 0
      add = 0;
    end %if
  end %for
  if add
  	ridges=horizont(n,:);
	  o=outindex([ridges, length(Polyhedron)]);
	  FacetVertices = [];
	  for q = 1:length(ridges)
		  FacetVertices(end+1,:) = Polyhedron(ridges(q)).c;
	  end %for
	  hyperplane = createhyperplane([FacetVertices; vertex]);
	  facet.inequal=halfspacefromhyp(hyperplane, Polyhedron(o).c);
	  facet.vert=[ridges,length(Polyhedron)];
	  facet.res=length(Inequalities)+1;
	  Inequalities(end+1,:)=facet.inequal;
    newfacets(end+1)=facet;
	  for p=1:length(ridges)
		  Polyhedron(ridges(p)).ineq(end+1)=facet;
	  end %for
    Polyhedron(end).ineq(end+1).inequal=facet.inequal;
    Polyhedron(end).ineq(end).vert=facet.vert;
	  Polyhedron(end).ineq(end).res=facet.res;
  end %if
end %for

%memory measurement
if memory < actmemory(whos)
  memory = actmemory(whos);
end %if
time = toc;
disp(time);