% function creates inequalities of endless faces
function Facets = endlessfacets(Facets, Endlessedges, Vertices,dim)
combinations = gencomb(dim-1,rows(Endlessedges));
directive = [];
for i = 1:rows(combinations)
  directive(i).directs = Endlessedges(combinations(i,:),:);  
end %for
%find possible normal vectors
possible = [];
for j = 1:length(directive)         
  Helpvertices = Vertices(1,:);
  for k = 1:rows(directive(j).directs)
    Helpvertices(end+1,:) = Vertices(1,:)+directive(j).directs(k,:);
  end %for
  hyperplane = createhyperplane(Helpvertices);
  poss = 1;
  for l = rows(Endlessedges)
    if round(10000*(hyperplane(1:end-1)*Endlessedges(l,:)'))< 0
      poss = 0;
    end %if
  end %for
  if poss
    possible = [possible;hyperplane(1:end-1)];
  end %if  
end %for
%create endless facets from the normals
for m = 1:rows(Vertices)
  for n = 1:rows(possible)
    hyperplane = hyperplanenormal(possible(n,:), Vertices(m,:));
    def = 0;
    contain = 1;
    for o = 1:rows(Vertices)
      diff = Vertices(o,:)*hyperplane(1:end-1)' - hyperplane(end);
      if ~(round(diff*10000) == 0)
        if ~def
          hyperplane = halfspacefromhyp(hyperplane,Vertices(o,:));
          def = 1;
        elseif diff>0
          %hyperplane does not contain this vertex
          contain = 0;
          break;
        end %if
      end %if
    end %for
    if contain
      Facets = [Facets;hyperplane];
    end %if
  end %for
end %for