%find initial simplex
function [Inequalities, Polyhedron, Vertices, memory] = inivertoineqcomb(Vertices)

%inicialization and trivial cases
dim = columns(Vertices);
Inequalities = [];
Polyhedron = [];
memory = 0;

if rows(Vertices) < dim + 1
	disp('Maly pocet vertexu, nemohou tvorit Polyhedron');
else 
	if dim < 2
		minik = min(Vertices);
		Polyhedron(1).c = minik;
		Polyhedron(1).ineq(1).inequal = [-1, -minik];
		Polyhedron(1).ineq(1).vert = 1;
		Polyhedron(1).ineq(1).res = 1;
		Inequalities = [-1, -minik];
		maxik = max(Vertices);
		Polyhedron(2).c = maxik;
		Polyhedron(2).ineq(1).inequal = [1, maxik];
		Polyhedron(2).ineq(1).vert = 2;
		Polyhedron(2).ineq(1).res = 2;
		Inequalities(end+1,:) = [1, maxik];
		Vertices = [];
	else

		%sort vertices
		[s, i] = sort(Vertices(:,1));
		Vertices = Vertices(i,:);
		
		%find vertices of the base of the simplex
		Mrzak = [];
		i = 3;
		pocvertex = Vertices(1,:);
		BaseVertices = Vertices(1:2,:);
		Help = (vectorik(pocvertex, Vertices(2,:)))';
		while columns(Help) < dim-1
			Help = [Help, (vectorik(pocvertex, Vertices(i,:)))'];
			if (rank(Help) == min([rows(Help), columns(Help)]))
				BaseVertices = [BaseVertices; Vertices(i,:)];
			else
				Help(:,end)=[];
				Mrzak = [Mrzak; Vertices(i,:)];
            end %if
			i = i + 1;
		end %while
	
		%create base of the simplex
		hyperplane = createhyperplane(BaseVertices);
		
    %find apex
		while vertexliesinhyp(Vertices(i,:), hyperplane)
			Mrzak = [Mrzak;Vertices(i,:)];
			i =i+1;
		end %while
		apex = Vertices(i,:);
    
    %create simplex
		[Inequalities, Polyhedron]=createsimplex(BaseVertices,hyperplane,apex);
		for j=1:rows(Mrzak);
			if vertexout(Mrzak(j,:),Inequalities)
				[Inequalities, Polyhedron, memory]= addvertex(Mrzak(j,:), Inequalities, Polyhedron);
      end %if
		end %for
		if i<rows(Vertices)
			Vertices = Vertices((i+1):end,:);
		else Vertices = [];
        end %if
    end %if
end %if

%memory measurement
if memory < actmemory(whos)
  memory = actmemory(whos);
end %if